{

regular expressions support
(c) autor unknown :-( received from Alex Denisenko
(c) portions by raVen

supported compilers: borland pascal 7.x, virtual pascal 2.0b+

}
{.$Define Debug}
{&Use32-,LocInfo+}
{$D+,L+,I-,R-,S-,Q-,X+}
unit RegExp;
interface
Uses Objects;

const
 RegExp_NSubExp = 128;
 Max_NSubExp    = RegExp_NSubExp - 1;

type
 CharPtr = PChar;
 SubExpArrPtr = ^SubExpArr;
 SubExpArr = array[0..Max_NSubExp] of CharPtr;
 RegExprPtr = ^RegExpr;
 RegExpr = record
  StartP, endP : SubExpArr;
  RegStart, RegANch : Char; { Internal use only. }
  RegMust : CharPtr;          { Internal use only. }
  RegMLen : Word;           { Internal use only. }
  rProgram : Array[0..0] of Byte;  { Unwarranted chumminess with compiler. }
 end;

 StringTablePtr = ^StringTable;
 StringTable    = array[0..0] of CharPtr;

 pRegExp = ^tRegExp;
 tRegExp = object(tObject)
 private
  RegParse    : CharPtr;          { Input-scan pointer. }
  RegReplace  : CharPtr;          { Mask for replace }
  RegCase     : Boolean;        { case sensitivity }
  RegNPar     : Integer;        { () count. }
  RegDummy    : Char;
  RegCode     : CharPtr;          { Code-emit pointer; &regdummy = don't. }
  RegSize     : Longint;        { Code size. }
  RegErrorMsg : ^String;
  RegInput    : CharPtr;          { String-input pointer. }
  RegBol      : CharPtr;          { Beginning of input, for ^ check. }
  RegStartP   : StringTablePtr; { Pointer to startp array. }
  RegEndP     : StringTablePtr; { Ditto for endp. }
  Mask1: RegExprPtr;
  procedure   RegError(const ErrStr: string);
  function    RegComp(Exp: CharPtr): RegExprPtr;
  function    RegExec(Prog: RegExprPtr; St: CharPtr ): boolean;
  function    Reg(paren: Word; var FlagP: Word): CharPtr;
  function    RegBranch(var FlagP: Word): CharPtr;
  function    RegPiece(var FlagP: Word): CharPtr;
  function    RegAtom(var FlagP: Word): CharPtr;
  function    RegNode(OP: char): CharPtr;
  function    RegNext(p: CharPtr): CharPtr;
  procedure   RegInsert(op: char; opnd: CharPtr);
  procedure   RegTail(p, val: CharPtr );
  procedure   RegOpTail(p, val: CharPtr);
  function    RegTry(prog: RegExprPtr; st: CharPtr): Boolean;
  function    RegMatch(prog: CharPtr): Boolean;
  function    RegRepeat(p: CharPtr): Word;
  procedure   RegSub(prog: RegExprPtr; Source, Dest: CharPtr);
  procedure   RegC(B: char); { emit (if appropriate) a byte of code }
{$IfDef Debug}
  procedure   RegDump(r: RegExprPtr);
  function    RegProp(op: CharPtr): String;
{$EndIf}
 public
  constructor Init(MaskStr: CharPtr);
  constructor InitStr(aMaskStr: String);
  destructor  Done; virtual;
  procedure   SetReplaceMask(st: CharPtr);
  function    IsValid: Boolean;
  function    MaskMatchStr(aaddr: String; CaseSense: Boolean): Boolean;
  function    MaskMatch(Addr: CharPtr; CaseSense: Boolean): Boolean;
  function    MaskReplace(Addr: CharPtr; CaseSense: Boolean): Boolean;
  function    GetRegErrorMsg: String;
 end;

 function GrepMatchAsc(WildCard: String; aStr: pChar; cs: Boolean): Boolean;
 function GrepMatch(WildCard, aStr: String; cs: Boolean): Boolean;
 function GrepSubAsc(WildCard: String; aStr,Repl: pChar; cs: Boolean): pChar;
 function GrepSub(WildCard, aStr, Repl: String; cs: Boolean): String;

{*
      ࠦ   ᨬ  ਢ ࠢ:

          c            ⠢     ᨬ      (訥   
                       쪨  㪢  ࠧ稬),  ᫨      
                        ᨬ.

          \c           ⠢      ᨬ,     ।
                       escape-᫥⥫쭮,  ᨭ⠪  ன
                       ᮢ       ᯮ짮      ப
                       ⠭ 몠       ᠬ  ᨬ  
                       (訥   쪨 㪢 ࠧ稬),  ᫨
                       \c   escape-᫥⥫쭮.

          .            ⠢    ᨬ ( 
                       ப).

          ^            ⠢  砫 ப.

          $            ⠢  殬 ப.

          [c1c2c3...]  ⠢    ᨬ    c1c2c3...
                       ࢠ ᨬ   c1-c2.

          [^c1c2c3...] ⠢   ᨬ,   祭
                        c1c2c3...

      ࠦ   㣨 ॣ ࠦ
      ᫥騬 ࠢ:

          r1r2     ⠢  r1     ࠧ  ᫥  r2
                   (⥭).

          r1 | r2  ⠢  r1  r2 (ୠ⨢).

          r*       ⠢  r, ७    ࠧ.

          r+       ⠢  r, ७ 1   ࠧ.

          r?       ⠢  r, ७ 0  1 ࠧ.

          (r)      ⠢  r, ।⠢ ᮡ 㯯.

  ć Ŀ
                                                                    
     &   ⠢ 室 ப.                                 
     \n  ⠢ ⥪, ᮯ⠢  㯯  'n'(0-9).  
                                                                    
  


   樠 ᨬ:

      \a   0x07   BEL          \v   0x0B   VT
      \b   0x08   BS           \f   0x0C   FF
      \t   0x09   HT           \r   0x0D   CR
      \n   0x0A   LF           \xHH    he-ᨬ
*}

implementation
uses Strings, rStrings, rAsciiz;

type
 RegOpPtr = ^RegOp;
 RegOp = Packed Record
  Op: Byte;
  Next: Word;
 end;

const
 OPHDR = SizeOf(RegOp);

 MAGIC = 0234;

 { definition number  opnd? meaning }
 PEND    = 0;   { no End of program. }
 BOL     = 1;   { no Match "" at beginning of line. }
 EOL     = 2;   { no Match "" at end of line. }
 ANY     = 3;   { no Match any one character. }
 ANYOF   = 4;   { str  Match any character in this string. }
 ANYBUT  = 5;   { str  Match any character not in this string. }
 BRANCH  = 6;   { node Match this alternative, or the next... }
 BACK    = 7;   { no Match "", "next" ptr points backward. }
 EXACTLY = 8;   { str  Match this string. }
 NOTHING = 9;   { no Match empty string. }
 STAR    = 10;  { node Match this (simple) thing 0 or more times. }
 PLUS    = 11;  { node Match this (simple) thing 1 or more times. }
 OPEN    = 20;  { no Mark this point in input as start of #n. }
                {  OPEN+1 is number 1, etc. }
 CLOSE   = 30;  { no Analogous to OPEN. }

{
 * Opcode notes:
 *
 * BRANCH       The set of branches constituting a single choice are hooked
 *              together with their "next" pointers, since precedence prevents
 *              anything being concatenated to any individual branch.  The
 *              "next" pointer of the last BRANCH in a choice points to the
 *              thing following the whole choice.  This is also where the
 *              final "next" pointer of each individual branch points; each
 *              branch starts with the operand node of a BRANCH node.
 *
 * BACK         Normal "next" pointers all implicitly point forward; BACK
 *              exists to make loop structures possible.
 *
 * STAR,PLUS    '?', and complex '*' and '+', are implemented as circular
 *              BRANCH structures using BACK.  Simple cases (one character
 *              per match) are implemented with STAR and PLUS for speed
 *              and to minimize recursive plunges.
 *
 * OPEN,CLOSE   ...are numbered at compile time.
}

{
 * Flags to be passed up and down.
}
 HASWIDTH = 01;  { Known never to match null string. }
 SIMPLE   = 02;  { Simple enough to be STAR/PLUS operand. }
 SPSTART  = 04;  { Starts with * or +. }
 WORST    = 0;   { Worst case. }

 META: Array[0..11] of Char = ('^', '$', '.', '[', '(', ')',
                               '|', '?', '+', '*', '\', Chr(0));

var
 LastRegErrorMsg: String;

function GrepMatchAsc(WildCard: String; aStr: pChar; cs: Boolean): boolean;
 var
  RgExp: tRegExp;
 begin
  if (aStr=nil) or (WildCard='') then exit;
  RgExp.InitStr(WildCard);
  GrepMatchAsc:=RgExp.MaskMatch(aStr,cs);
  RgExp.Done;
 end;

function GrepMatch(WildCard, aStr: String; cs: Boolean): Boolean;
 var
  RgExp: tRegExp;
 begin
  if (aStr='') or (WildCard='') then exit;
  RgExp.InitStr(WildCard);
  GrepMatch:=RgExp.MaskMatchStr(aStr,cs);
  RgExp.Done;
 end;

function GrepSubAsc(WildCard: String; aStr,Repl: pChar; cs: Boolean): pChar;
 var
  RgExp: tRegExp;
  r,r1: pChar;
 begin
  GrepSubAsc:=nil;
  if (aStr=nil) or (Repl=nil) or (WildCard='') then exit;
  with (RgExp) do
   begin
    InitStr(WildCard);
    if (not MaskMatch(aStr,cs)) then
     begin
      Done;
      exit;
     end;
    GetMem(r,AscMaxLen);
    RegSub(Mask1,Repl,r);
    GrepSubAsc:=StrNew(r);
    FreeMem(r,AscMaxlen);
    Done;
   end;
 end;

function GrepSub(WildCard, aStr, Repl: String; cs: Boolean): String;
 var
  p1,p2,p3: pChar;
 begin
  p1:=PasStr(aStr);
  p2:=PasStr(Repl);
  p3:=GrepSubAsc(WildCard,p1,p2,cs);
  GrepSub:=StrPas(p3);
  StrFree(p3);
  StrFree(p2);
  StrFree(p1);
 end;

function IsMult(c: char): Boolean;
 begin
  if (c='*') or (c='+') or (c='?') then IsMult:=True else IsMult:=False;
 end;

function strcspn(s1, s2 : CharPtr) : word;
 var
  Scan1, Scan2: CharPtr;
  Count: word;
 begin
  count:=0;
  scan1:=s1;
  while scan1^<>#0 do
   begin
    scan2:=s2;
    while scan2^<>#0 do
     begin
      if scan1^=scan2^ then
       begin
        StrcSpn:=Count;
        Exit;
       end;
      Inc(Scan2);
     end;
    Inc(Count);
    Inc(Scan1);
   end;
  StrcSpn:=Count;
 end;

{ ----------   convert escape sequences  -------------}
const
 NOT_HEX = 16;
 ET_END  = 7;
type
 ET = record
  i,o: char;
 end;
const
 hex_val: Array[0..(Ord('f')-Ord('A'))] of Byte =
          (10,11,12,13,14,15, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0,
           10,11,12,13,14,15 );
 Escape_Test: Array[0..Et_End] of Et =
              ((i:'n';o:#10), (i:'t';o:#9), (i:'f';o:#12), (i:'b';o:#8),
               (i:'r';o:#13), (i:'a';o:#7), (i:'v';o:#11), (i:#0;o:#0));

function escape( var p : CharPtr) : char;
 function ctohex( c : char ) : byte;
 { interpret 1 character as hex }
  var
   t: Byte;
  begin
   if c in ['0'..'9'] then
    begin
     CToHex:=Ord(c)-Ord('0');
     exit;
    end;
   if c in ['A'..'f'] then
    begin
     t:=Hex_Val[Ord(c)-Ord('A')];
     if t<>0 then
      begin
       CToHex:=T;
       exit;
      end;
    end;
   CToHex:=Not_Hex;
  end;
 var
  x, xx, i: Word;
 begin
  if p^=Chr(0) then
   begin
    Escape:='\';
    Exit;
   end;
  Escape_Test[Et_End].i:=p^;
  i:=0;
  while Escape_Test[i].i<>p^ do Inc(i);
  if i<>Et_End then
   begin
    Inc(p);
    Escape:=Escape_Test[i].o;
    Exit;
   end;
  if p^ in ['0'..'7'] then
   begin
    x:=Ord(p^)-Ord('0');
    Inc(p);
    if p^ in ['0'..'7'] then
     begin
      x:=(x shl 3)+(Ord(p^)-Ord('0'));
      Inc(p);
      if p^ in ['0'..'7'] then
       begin
        x:=(x shl 3)+(Ord(p^)-Ord('0'));
        Inc(p);
       end;
     end;
    escape := Chr(x);
    exit;
   end;
  if p^='x' then
   begin
    Inc(p);
    x:=CToHex(p^);
    if x = NOT_HEX then
     begin
      Escape:='x';
      Exit;
     end;
    Inc(p);
    xx:=CToHex(p^);
    if xx<>Not_Hex then
     begin
      x:=(x shl 4)+xx;
      Inc(p);
     end;
    escape := Chr(x);
    exit;
   end;
  Escape:=p^;
  Inc(p);
 end;

type
{$IfDef VirtualPascal}
 SearchFunc = function(Str: CharPtr; C: Char): CharPtr;
 CompareFunc = function(Str1, Str2: PChar; MaxLen: Longint): Longint;
{$Else}
 SearchFunc = function(Str: CharPtr; C: Char): CharPtr;
 CompareFunc = function(Str1, Str2: CharPtr; MaxLen: Word): Integer;
{$EnDif}

var
 FindChar: SearchFunc;
 CompString: CompareFunc;

function StrIScan(Str: CharPtr; C: Char): CharPtr; far;
 var
  c1, c2: Char;
  p1, p2: CharPtr;
 begin
  c1:=UpCase(C); c2:=LoCase(C);
  if c1=c2 then StrIScan:=StrScan(Str, C) else
   begin
    p1:=StrScan(Str, c1); p2:=StrScan(Str, c2);
    if p1<>nil then
     begin
      StrIScan:=p1;
      if p2<>nil then if p2<p1 then StrIScan:=p2;
     end
    else
     StrIScan:=p2;
   end;
 end;

{
 - regcomp - compile a regular expression into internal code
 *
 * We can't allocate space until we know how big the compiled form will be,
 * but we can't compile it (and thus know how big it is) until we've got a
 * place to put the code.  So we cheat:  we compile it twice, once with code
 * generation turned off and size counting turned on, and once "for real".
 * This also means that we don't allocate space until we are sure that the
 * thing really will compile successfully, and we never have to move the
 * code and thus invalidate pointers into it.  (Note that it has to be in
 * one piece because free() must be able to free it all.)
 *
 * Beware that the optimization-preparation code in here knows about some
 * of the structure of the compiled regexp.
}
function tRegExp.RegComp(exp: CharPtr): RegExprPtr;
 var
  r: RegExprPtr;
  Scan, Longest: CharPtr;
  Len, Flags: word;
 begin
  if exp=nil then
   begin
    RegError('NULL argument');
    RegComp:=nil;
    Exit;
   end;

  { First pass: determine size, legality. }
  RegParse:=Exp;
  RegNPar:=1;
  RegSize:=0;
  RegCode:=@RegDummy;
  RegC(Chr(MAGIC));
  if Reg(0, Flags)=nil then
   begin
    RegComp:=nil;
    Exit;
   end;

  { Small enough for pointer-storage convention? }
  if regsize>=32767 then   { Probably could be 65535L. }
   begin
    RegError('regexp too big');
    RegComp:=nil;
    Exit;
   end;

  { Allocate space. }
  GetMem(r, SizeOf(RegExpr)+Word(RegSize));
  if r=nil then
   begin
    RegError('out of space');
    RegComp:=nil;
    Exit;
   end;

  { Second pass: emit code. }
  RegParse:=exp;
  RegNPar:=1;
  RegCode:=@r^.rProgram;
  RegC(Chr(Magic));
  if reg(0, Flags)=nil then
   begin
    RegComp:=nil;
    Exit;
   end;

  { Dig out information for optimizations. }
  r^.RegStart:=#0; { Worst-case defaults. }
  r^.RegAnch:=#0;
  r^.RegMust:=nil;
  r^.RegMLen:=0;
  Scan:=CharPtr(@r^.rProgram);
  Inc(Scan);     { First BRANCH. }
  if RegOpPtr(RegNext(Scan))^.OP=PEnd then  { Only one top-level choice. }
   begin
    Inc(Scan,OPHDR);
     { Starting-point info. }
    if RegOpPtr(scan)^.OP=EXACTLY then r^.regstart:=(Scan+OPHDR)^
    else if RegOpPtr(Scan)^.OP=BOL then Inc(r^.RegAnch);

    {
     * If there's something expensive in the r.e., find the
     * longest literal string that must appear and make it the
     * regmust.  Resolve ties in favor of later strings, since
     * the regstart check works with the beginning of the r.e.
     * and avoiding duplication strengthens checking.  Not a
     * strong reason, but sufficient in the absence of others.
    }
    if (flags and SPSTART)<>0 then
     begin
      Longest:=nil;
      Len:=0;
      while Scan<>nil do
       begin
        if (RegOpPtr(scan)^.OP=Exactly) and (StrLen(scan+OPHDR)>=len) then
         begin
          Longest:=Scan+OPHDR;
          Len:=StrLen(scan+OPHDR);
         end;
        scan:=RegNext(scan);
       end;
      r^.RegMust:=Longest;
      r^.RegMLen:=Len;
     end
   end;
  {$IfDef Debug}
  regdump(r);
  {$EndIf}
  regcomp := r;
 end;

procedure tRegExp.Regc(b: Char); { emit (if appropriate) a byte of code }
 begin
  if RegCode<>@RegDummy then
   begin
    RegCode^:=b;
    Inc(regcode);
   end
  else
   Inc(RegSize);
 end;

{
 - reg - regular expression, i.e. main body or parenthesized thing
 *
 * Caller must absorb opening parenthesis.
 *
 * Combining parenthesis handling with the base level of regular expression
 * is a trifle forced, but the need to tie the tails of the branches to what
 * follows makes it hard to avoid.
}

function tRegExp.Reg(Paren: Word; var FlagP: Word): CharPtr;
 var
  Ret, Br, Ender: CharPtr;
  Parno, Flags: Word;
 begin
  FlagP:=HasWidth;
  { Make an OPEN node, if parenthesized. }
  if Paren<>0 then
   begin
    if RegNPar>=RegExp_NSUBEXP then
     begin
      RegError('too many ()');
      Reg:=nil;
      Exit;
     end;
    Parno:=RegNPar;
    Inc(regnpar);
    Ret:=RegNode(Chr(OPEN+parno));
   end
  else
   Ret:=nil;
  { Pick up the branches, linking them together. }
  br:=RegBranch(Flags);
  if Br=nil then
   begin
    Reg:=nil;
    Exit;
   end;
  if Ret<>nil then RegTail(ret, br)
  else Ret:=Br;
  if (flags and HASWIDTH)=0 then FlagP:=FlagP and (not HasWidth);
  FlagP:=FlagP or (Flags and SPSTART);
  while (RegParse^='|') do
   begin
    Inc(regparse);
    Br:=RegBranch(Flags);
    if Br=nil then
     begin
      Reg:=nil;
      Exit;
     end;
    RegTail(Ret, Br);
    if (Flags and HASWIDTH)=0 then FlagP:=FlagP and (not HasWidth);
    FlagP:=FlagP or (Flags and SPSTART);
   end;

  { Make a closing node, and hook it on the end. }
  if Paren<>0 then Ender:=RegNode(Chr(Close+Parno))
  else Ender:=RegNode(Chr(PEnd));
  RegTail(Ret, Ender);

  { Hook the tails of the branches to the closing node. }
  Br:=Ret;
  while Br<>nil do
   begin
    RegOpTail(Br, Ender);
    br:=RegNext(Br);
   end;

  { Check for proper termination. }
  if (Paren<>0) and (RegParse^<>')') then
   begin
    Inc(regparse);
    Regerror('unmatched ()');
    Reg:=nil;
    Exit;
   end
  else
   begin
    if Paren<>0 then Inc(RegParse);
    if (Paren=0) and (RegParse^<>#0) then
     begin
      if RegParse^=')' then
       begin
        RegError('unmatched ()');
        Reg:=nil;
        Exit;
       end
      else
       begin
        RegError('junk on end');
        Reg:=nil;
        Exit;
       end;
     end;
   end;
  Reg:=Ret;
 end;

constructor tRegExp.InitStr(aMaskStr: String);
 var
  MaskStr: Array [0..255] of Char;
 begin
  RegParse:=nil;
  RegReplace:=nil;
  RegNPar:=0;
  RegDummy:=Chr(0);
  RegCode:=nil;
  RegSize:=0;
  RegInput:=nil;
  RegBol:=nil;
  RegStartP:=nil;
  RegEndP:=nil;
  RegErrorMsg:=nil;
  FillChar(MaskStr, SizeOf(MaskStr), 0);
  Move(aMaskStr[1], MaskStr, Length(aMaskStr));
  Mask1:=RegComp(MaskStr);
 end;

constructor tRegExp.Init(MaskStr : CharPtr);
 begin
  RegParse:=nil;
  RegReplace:=nil;
  RegNPar:=0;
  RegDummy:=Chr(0);
  RegCode:=nil;
  RegSize:=0;
  RegInput:=nil;
  RegBol:=nil;
  RegStartp:=nil;
  RegEndP:=nil;
  RegErrorMsg:=nil;
  Mask1:=RegComp(MaskStr);
 end;

destructor tRegExp.Done;
 begin
  if Mask1<>nil then  FreeMem(Mask1, SizeOf(RegExpr)+Word(RegSize));
  if RegReplace<>nil then StrDispose(RegReplace);
 end;

procedure tRegExp.regerror(Const ErrStr: string);
 begin
  RegErrorMsg:=@ErrStr;
  LastRegErrorMsg:=ErrStr;
 end;

{
 - regbranch - one alternative of an | operator
 *
 * Implements the concatenation operator.
}
function tRegExp.RegBranch(var FlagP: Word): CharPtr;
 var
  Ret, Chain, Latest: CharPtr;
  Flags : word;
 begin
  FlagP:=Worst;
  Ret:=RegNode(Chr(Branch));
  Chain:=nil;
  while (RegParse^<>#0) and (RegParse^<>'|') and (RegParse^<>')') do
   begin
    Latest:=RegPiece(Flags);
    if latest = nil then
     begin
      RegBranch:=nil;
      Exit;
     end;
    Flagp:=FlagP or (Flags and HasWidth);
    if Chain=nil then Flagp:=Flagp or (Flags and SpStart)
    else RegTail(Chain, Latest);
    Chain:=Latest;
   end;
  if Chain=nil then RegNode(Chr(Nothing));
  regbranch := ret;
 end;

{
 - regpiece - something followed by possible [*+?]
 *
 * Note that the branching code sequences used for ? and the general cases
 * of * and + are somewhat optimized:  they use the same NOTHING node as
 * both the endmarker for their branch list and the body of the last branch.
 * It might seem that this node could be dispensed with entirely, but the
 * endmarker role is not redundant.
}
function tRegExp.RegPiece(var FlagP: Word): CharPtr;
 var
  Ret, Next: CharPtr;
  Op: char;
  Flags: word;
 begin
  Ret:=RegAtom(Flags);
   if Ret=nil then
    begin
     RegPiece:=nil;
     Exit;
    end;
   Op:=RegParse^;
   if not IsMult(Op) then
    begin
     Flagp:=Flags;
     RegPiece:=Ret;
     Exit;
    end;
   if ((Flags and HasWidth)=0) and (Op<>'?') then
    begin
     RegError('*+ operand could be empty');
     RegPiece:=nil; exit;
    end;
   if op='+' then Flagp:=Worst or HasWidth
   else FlagP:=Worst or SpStart;
   if (op='*') and ((Flags and Simple)<>0) then Reginsert(Chr(Star), Ret)
   else if op='*' then
    begin
     RegInsert(Chr(Branch), ret);           { Either x }
     RegOptail(Ret, RegNode(Chr(Back)));    { and loop }
     RegOptail(Ret, Ret);              { back }
     RegTail(Ret, Regnode(Chr(Branch)));    { or }
     RegTail(Ret, Regnode(Chr(Nothing)));   { null. }
    end
   else if (op='+') and ((Flags and Simple)<>0) then RegInsert(Chr(Plus), Ret)
   else if op='+' then
    begin
     Next:=RegNode(Chr(Branch));          { Either }
     RegTail(Ret, Next);
     RegTail(Regnode(Chr(Back)), Ret);      { loop back }
     RegTail(Next, RegNode(Chr(Branch)));   { or }
     RegTail(Ret, RegNode(Chr(Nothing)));   { null. }
    end
   else if op='?' then
    begin
     RegInsert(Chr(Branch), Ret);           { Either x }
     RegTail(Ret, RegNode(Chr(Branch)));    { or }
     Next:=RegNode(Chr(Nothing));         { null. }
     RegTail(Ret, Next);
     RegOptail(Ret, Next);
    end;
   Inc(RegParse);
   if IsMult(RegParse^) then
    begin
     RegError('nested *?+');
     RegPiece:=nil;
     Exit;
    end;
   RegPiece:=Ret;
  end;

{
 - regatom - the lowest level
 *
 * Optimization:  gobbles an entire sequence of ordinary characters so that
 * it can turn them into a single node, which is smaller to store and
 * faster to run.  Backslashed characters are exceptions, each becoming a
 * separate node; the code is simpler that way and it's not worth fixing.
}
function tRegExp.regatom(var FlagP: Word): CharPtr;
 var
  Ret: CharPtr;
  Flags: Word;
  C, Ender: Char;
  Len, ClassThe, ClassEnd: Word;
 begin
  FlagP:=Worst;
  c:=RegParse^;
  Inc(RegParse);
  case c of
   '^': Ret:=RegNode(Chr(Bol));
   '$': Ret:=RegNode(Chr(Eol));
   '.':
    begin
     Ret:=RegNode(Chr(Any));
     Flagp:=FlagP or (HasWidth or Simple);
    end;
  '[':
    begin
     if RegParse^='^' then
      begin
       Ret:=RegNode(Chr(AnyBut));
       Inc(RegParse);
      end
     else Ret:=RegNode(Chr(AnyOf));
     if (RegParse^=']') or (RegParse^='-') then
      begin
       Regc(RegParse^);
       Inc(RegParse);
      end;
     while (regparse^ <> #0) and (regparse^ <> ']') do
      begin
       if RegParse^='-' then
        begin
         Inc(RegParse);
         if (RegParse^=']') or (RegParse^=#0) then regc('-')
         else
          begin
           ClassThe:=Ord((RegParse-2)^)+1;
           ClassEnd:=Ord(RegParse^);
           if ClassThe>(ClassEnd+1) then
            begin
             RegError('invalid [] range');
             RegAtom:=nil;
             Exit;
            end;
           while ClassThe<=ClassEnd do
            begin
             Regc(Chr(ClassThe));
             Inc(classThe);
            end;
           Inc(regparse);
          end
        end
       else
        begin
         if RegParse^='\' then
          begin
           Inc(RegParse);
           Regc(Escape(RegParse));
          end
         else
          begin
           Regc(RegParse^);
           Inc(RegParse);
          end;
        end;
      end;
     Regc(#0);
     if RegParse^<>']' then
      begin
       RegError('unmatched []');
       RegAtom:=nil;
       Exit;
      end;
     Inc(regparse);
     Flagp:=FlagP or (HasWidth or Simple);
    end;
  '(':
    begin
     Ret:=Reg(1, Flags);
     if Ret=nil then
      begin
       RegAtom:=nil;
       Exit;
      end;
     Flagp:=Flagp or (Flags and (HasWidth or SpStart));
    end;
  #0, '|', ')':
    begin
     RegError('internal urp');
     RegAtom:=nil;
     Exit;
    end;
  '?', '+', '*':
    begin
     RegError('?+* follows nothing');
     RegAtom:=nil;
     Exit;
    end;
  '\':
    begin
     if RegParse^=#0 then
      begin
       RegError('trailing \');
       RegAtom:=nil;
       Exit;
      end;
     Ret:=RegNode(Chr(Exactly));
     Regc(Escape(RegParse));
     Regc(#0);
     Flagp:=Flagp or (HasWidth or Simple);
    end;
   else
    begin
     Dec(RegParse);
     Len:=StrCSpn(RegParse, @Meta);
     if Integer(Len)<=0 then
      begin
       RegError('internal disaster');
       RegAtom:=nil;
       Exit;
      end;
     Ender:=(RegParse+Len)^;
     if (Len>1) and IsMult(Ender) then Dec(Len);
     FlagP:=FlagP or HasWidth;
     if Len=1 then FlagP:=FlagP or Simple;
     Ret:=RegNode(Chr(Exactly));
     while (len > 0) do
      begin
       Regc(RegParse^);
       Inc(RegParse);
       Dec(Len);
      end;
     Regc(#0);
    end;
   end;
  RegAtom:=Ret;
 end;

{
 - regnode - emit a node
}
function tRegExp.RegNode(op: Char): CharPtr;
 var
  Ret, p: CharPtr;
 begin
  Ret:=RegCode;
  if Ret=@RegDummy then
   begin
    Inc(RegSize,OpHdr);
    RegNode:=Ret;
    Exit;
   end;
  p:=Ret;
  p^:=op;
  Inc(p);
  p^:=#0;    { Null "next" pointer. }
  Inc(p);
  p^:=#0;
  Inc(p);
  RegCode:=p;
  RegNode:=ret;
 end;

{
 - regnext - dig the "next" pointer out of a node
}
function tRegExp.RegNext(p: CharPtr): CharPtr;
 var
  offset : word;
 begin
  if p=@RegDummy then
   begin
    RegNext:=nil;
    Exit;
   end;
  offset := RegOpPtr(p)^.NEXT;
  if Offset=0 then
   begin
    RegNext:=nil;
    Exit;
   end;
  if RegOpPtr(p)^.OP=Back then RegNext:=p-Offset
  else RegNext:=p+Offset;
 end;

{
 - reginsert - insert an operator in front of already-emitted operand
 *
 * Means relocating the operand.
}
procedure tRegExp.RegInsert(op: Char; opnd: CharPtr);
 var
  Src, Dst, Place: CharPtr;
 begin
  if RegCode=@RegDummy then
   begin
    Inc(RegSize,OpHdr);
    Exit;
   end;
  Src:=RegCode;
  Inc(RegCode,OpHdr);
  Dst:=RegCode;
  while (Src>opnd) do
   begin
    Dec(Dst);
    Dec(Src);
    Dst^:=Src^;
   end;
  Place:=opnd;
  Place^:=op; Inc(Place);
  Place^:=#0; Inc(Place);
  Place^:=#0; Inc(Place);
 end;

{
 - regtail - set the next-pointer at the end of a node chain
}
procedure tRegExp.RegTail(p, Val: CharPtr);
 var
  Scan, Temp: CharPtr;
  Offset: word;
 begin
  if p=@RegDummy then Exit;
  { Find last node. }
  Scan:=p;
  while True do
   begin
    Temp:=RegNext(Scan);
    if Temp=nil then Break;
    Scan:=Temp;
   end;
  if RegOpPtr(scan)^.OP=Back then Offset:=Scan-Val
  else OffSet:=Val-Scan;
  RegOpPtr(Scan)^.Next:=Offset;
 end;

{
 - regoptail - regtail on operand of first argument; nop if operandless
}
procedure tRegExp.regoptail( p, val : CharPtr );
 begin
  { "Operandless" and "op != BRANCH" are synonymous in practice. }
  if (p=nil) or (p=@RegDummy) or (RegOpPtr(p)^.OP<>Branch) then Exit;
  RegTail(p+OpHdr, Val);
 end;

{
 - regexec - match a regexp against a string
}
function tRegExp.RegExec(Prog: RegExprPtr; St: CharPtr): Boolean;
 var
  s: CharPtr;
 begin
  if (Prog=nil) or (St=nil) then
   begin
    RegError('NULL parameter');
    RegExec:=False;
    Exit;
   end;

  if Prog^.rProgram[0]<>Magic then
   begin
    RegError('corrupted program');
    RegExec:=false;
    Exit;
   end;

  if RegCase then
   begin
    FindChar:=StrScan;
    CompString:=StrLComp;
   end
  else
   begin
    FindChar:=StrIScan;
    CompString:=StrLIComp;
   end;

  if Prog^.RegMust<>nil then
   begin
    s:=St;
    s:=FindChar(s, Prog^.RegMust^);
    while s<>nil do
     begin
      if CompString(s, Prog^.RegMust, Prog^.RegMLen)=0 then break;
      Inc(s);
      s:=FindChar(s, Prog^.RegMust^);
     end;
    if s=nil then
     begin
      RegExec:=False;
      Exit;
     end;
   end;

  RegBol:=St;

  if Ord(Prog^.RegAnch)<>0 then
   begin
    RegExec:=RegTry(Prog, St);
    Exit;
   end;

  s:=St;
  if Ord(Prog^.RegStart)<>0 then
   begin
    s:=FindChar(s, Prog^.RegStart);
    while s<>nil do
     begin
      if RegTry(Prog, S) then
       begin
        RegExec:=True;
        Exit;
       end;
      Inc(s);
      s:=FindChar(s, Prog^.RegStart);
     end
   end
  else
   begin
    Dec(s);
    repeat
     Inc(s);
     if RegTry(prog, s) then
      begin
       RegExec:=True;
       Exit;
      end;
    until s^ = #0;
   end;

  RegExec:=False;
 end;

{
 - regtry - try match at specific point
}
function tRegExp.RegTry(Prog: RegExprPtr; st: CharPtr ): Boolean;
 var
  i: Word;
  sp, ep: StringTablePtr;
 begin
  RegInput:=St;
  RegStartp:=@Prog^.StartP;
  RegEndP:=@Prog^.EndP;

  sp:=@Prog^.StartP;
  ep:=@Prog^.EndP;
  for i:=1 to Max_NSubExp do
   begin
    sp^[i]:=nil;
    ep^[i]:=nil;
   end;
  if RegMatch(CharPtr(@Prog^.rProgram)+1) then
   begin
    Prog^.StartP[0]:=st;
    Prog^.EndP[0]:=RegInput;
    Regtry:=True;
   end
  else RegTry:=False;
 end;

{
 - regmatch - main matching routine
 *
 * Conceptually the strategy is simple:  check to see whether the current
 * node matches, call self recursively to see whether the rest matches,
 * and then act accordingly.  In practice we make some effort to avoid
 * recursion, in particular by going through "ordinary" nodes (that don't
 * need to know whether the rest of the match failed) by a loop instead of
 * by recursion.
}

function tRegExp.RegMatch(Prog: CharPtr): Boolean;
 var
  Scan, Next, opnd, Save: CharPtr;
  Len, No, Min: Integer;
  NextCh: Char;
 begin
  Scan:=Prog;

  while Scan<>nil do
   begin
    Next:=RegNext(Scan);
    case RegOpPtr(scan)^.OP of
     Bol:
      if RegInput<>RegBol then
       begin
        RegMatch:=False;
        Exit;
       end;
     Eol:
      if RegInput^<>#0 then
       begin
        RegMatch:=False;
        Exit;
       end;
     Any:
      begin
       if RegInput^=#0 then
        begin
         RegMatch:=False;
         Exit;
        end;
       Inc(reginput);
      end;
     Exactly:
      begin
       opnd:=Scan+OpHdr;
       if (RegCase and (opnd^<>RegInput^)) or
         ((not RegCase) and (UpCase(opnd^)<>UpCase(RegInput^))) then
        begin
         RegMatch:=False;
         Exit;
        end;
       Len:=StrLen(opnd);
       if (Len>1 ) and (CompString(opnd, RegInput, Len)<>0) then
        begin
         RegMatch:=False;
         Exit;
        end;
       Inc(RegInput, Len);
      end;
     AnyOf:
      begin
       if (RegInput^=#0) or (StrScan(Scan + OPHDR, RegInput^)=nil) then
        begin
         RegMatch:=False;
         Exit;
        end;
       Inc(RegInput);
      end;
     AnyBut:
      begin
       if (RegInput^=#0) or (StrScan(Scan+OPHDR, RegInput^)<>nil) then
        begin
         RegMatch:=False;
         Exit;
        end;
       Inc(RegInput);
      end;
     Nothing: ;
     Back: ;
     Open+1,
     Open+2,
     Open+3,
     Open+4,
     Open+5,
     Open+6,
     Open+7,
     Open+8,
     Open+9:
      begin
       no:=RegOpPtr(Scan)^.OP-Open;
       Save:=RegInput;
       if RegMatch(Next) then
        begin
         if RegStartP^[No]=nil then RegStartP^[No]:=Save;
         RegMatch:=True;
         Exit;
        end
       else
        begin
         RegMatch:=False;
         Exit;
        end;
      end;

     Close+1,
     Close+2,
     Close+3,
     Close+4,
     Close+5,
     Close+6,
     Close+7,
     Close+8,
     Close+9:
      begin
       No:=RegOpPtr(scan)^.OP - Close;
       Save:=RegInput;
       if RegMatch(Next) then
        begin
         if RegEndP^[No]=nil then RegEndP^[No]:=Save;
         RegMatch:=True;
         Exit;
        end
       else
        begin
         RegMatch:=False;
         Exit;
        end;
      end;
     Branch:
      begin
       if RegOpPtr(next)^.OP<>Branch then Next:=Scan+OpHdr
       else
        begin
         repeat
          Save:=RegInput;
          if RegMatch(Scan+OpHdr) then
           begin
            RegMatch:=True;
            Exit;
           end;
          RegInput:=Save;
          Scan:=RegNext(Scan);
         until (Scan=nil) or (RegOpPtr(scan)^.OP<>Branch);
         RegMatch:=False;
         Exit;
        end;
      end;
     Star,
     Plus:
      begin
       NextCh:=Chr(0);
       if RegOpPtr(Next)^.OP=Exactly then NextCh:=(next+OpHdr)^;
       if RegOpPtr(Scan)^.OP=Star then min:=0
       else min:=1;
       Save:=RegInput;
       No:=RegRepeat(Scan+OpHdr);
       while No>=Min do
        begin
         if (NextCh=#0) or (RegInput^=NextCh) then
         if RegMatch(Next) then
          begin
           RegMatch:=True;
           Exit;
          end;
         Dec(No);
         RegInput:=Save;
         Inc(RegInput, No);
        end;
       RegMatch:=False;
       Exit;
      end;

     Pend:
      begin
       RegMatch:=True;
       Exit;
      end;
     else
      begin
       RegError('memory corruption');
       RegMatch:=False;
       Exit;
      end;
     end;
    Scan:=Next;
   end;
  RegError('corrupted pointers');
  RegMatch:=False;
 end;

{
 - regrepeat - repeatedly match something simple, report how many
}
function tRegExp.RegRepeat(p: CharPtr): Word;
 var
  Count: Word;
  Scan, opnd: CharPtr;
 begin
  count := 0;
  Scan:=RegInput;
  opnd:=p+OpHdr;
  case RegOpPtr(p)^.OP of
   Any:
    begin
     Count:=StrLen(Scan);
     Inc(Scan,Count);
    end;
   Exactly:
    while (opnd^=Scan^) or
         ((not RegCase) and (UpCase(opnd^) = UpCase(Scan^))) do
     begin
      Inc(Count);
      Inc(Scan);
     end;
   AnyOf:
    while (Scan^<>#0) and (StrScan(opnd, Scan^)<>nil) do
     begin
      Inc(Count);
      Inc(Scan);
     end;
   AnyBut:
    while (Scan^<>#0) and (StrScan(opnd, Scan^)=nil) do
     begin
      Inc(Count);
      Inc(Scan);
     end;
    else
     begin
      RegError('internal foulup');
      Count:=0;
     end;
   end;
  RegInput:=Scan;
  RegRepeat:=Count;
 end;

function tRegExp.GetRegErrorMsg: String;
 begin
  if RegErrorMsg=nil then GetRegErrorMsg:='' else GetRegErrorMsg:=RegErrorMsg^;
 end;

function tRegExp.isValid: Boolean;
 begin
  IsValid:=Mask1<>nil;
 end;

function tRegExp.MaskMatch(Addr: CharPtr; CaseSense: Boolean ): Boolean;
 begin
  RegCase:=CaseSense;
  if Mask1=nil then maskMatch := false
  else MaskMatch:=Regexec(Mask1, Addr);
 end;

function tRegExp.MaskMatchStr(aAddr: String; CaseSense: Boolean ): Boolean;
 var
  Addr: Array [0..255] of Char;
 begin
  FillChar(Addr, SizeOf(Addr), 0);
  Move(aAddr[1], Addr, Length(aAddr));
  RegCase:=CaseSense;
  if Mask1=nil then MaskMatchStr:=false
  else MaskMatchStr:=Regexec(Mask1, Addr);
 end;

{
 - regsub - perform substitutions after a regexp match
}
procedure tRegExp.RegSub(Prog: RegExprPtr; Source, Dest: CharPtr);
 var
  Src, Dst: CharPtr;
  c: Char;
  No: Integer;
  Len: Word;
 begin
  if (Prog=Nil) or (Source=nil) or (Dest=nil) then
   begin
    RegError('NULL parm to regsub');
    Exit;
   end;
  if Prog^.rProgram[0]<>Magic then
   begin
    RegError('damaged regexp fed to regsub');
    Exit;
   end;

  Src:=Source;
  Dst:=Dest;

  c:=Src^;
  Inc(Src);
  while (c<>Chr(0)) do
   begin
    if c='&' then No:=0
    else if (c='\') and (Ord('0')<=Ord(Src^)) and (Ord(Src^)<=Ord('9')) then
     begin
      No:=Ord(Src^)-Ord('0')+1;
      Inc(Src);
     end
    else No:=-1;
    if No<0 then
     begin
      if (c='\') then c:=Escape(Src);
      Dst^:=C;
      Inc(Dst);
     end
    else if (Prog^.StartP[No]<>nil) and (Prog^.EndP[No]<>nil) then
     begin
      Len:=Prog^.EndP[No]-Prog^.StartP[No];
      StrLCopy(Dst, Prog^.StartP[No], Len);
      Inc(Dst,Len);
      if (Len<>0) and ((Dst-1)^=Chr(0)) then
       begin
        RegError('damaged match string');
        Exit;
       end;
     end;
    c:=Src^;
    Inc(src);
   end;
  Dst^:=Chr(0);
 end;

procedure tRegExp.SetReplaceMask(St: CharPtr);
 begin
  if RegReplace<>nil then StrDispose(RegReplace);
  RegReplace:=StrNew(St);
 end;

function tRegExp.MaskReplace(addr: CharPtr; CaseSense: Boolean): Boolean;
  var
   A: pChar;
   Len: Word;
   p: CharPtr;
  begin
   RegCase:=CaseSense;
   if (Mask1=nil) or (RegReplace=nil) then MaskReplace:=False
   else
    if RegExec(Mask1, Addr) then
     begin
      Pointer(p):=Pointer(A);
      Len:=Mask1^.StartP[0]-Addr;
      if Len<>0 then
       begin
        StrLCopy(p, Addr, Len);
        Inc(p, Len);
       end;
      RegSub(Mask1, RegReplace, p);
      StrCat(pChar(A), Mask1^.EndP[0]);
      StrCopy(Addr, pChar(A));
      MaskReplace := True;
     end
    else MaskReplace:=False;
  end;

{$IfDef Debug}
{
 - regdump - dump a regexp onto stdout in vaguely comprehensible form
}
procedure tRegExp.RegDump(r: RegExprPtr);
 var
  s, Next: CharPtr;
  op: Byte;
 begin
  op:=Exactly;
  s:=@r^.rProgram;
  Inc(s);
  while op<>PEnd do
   begin
    op:=RegOpPtr(s)^.OP;
    Write(Integer(s-@r^.rProgram), RegProp(s));
    Next:= RegNext(s);
    if Next=nil then Write('(0)')
    else Write('(',Integer(s-@r^.rProgram)+Integer(Next-s),')');
    Inc(s,OpHdr);
    if (op=AnyOf) or (op=AnyBut) or (op=Exactly) then
     begin
      while s^<>Chr(0) do
       begin
        Write(s^);
        Inc(s);
       end;
      Inc(s);
     end;
   end;
  WriteLn;

  if r^.RegStart<>Chr(0) then Write('start "', r^.regstart,'"');
  if r^.RegAnch<>Chr(0) then Write('anchored ');
  if r^.RegMust<>nil then Write('must have "', StrPas(r^.regmust),'"');
  WriteLn;
 end;

{
 - regprop - printable representation of opcode
}
function tRegExp.RegProp(op: CharPtr): String;
 var
  Buf, p: String;
 begin
  buf := ':';
  case RegOpPtr(op)^.OP of
   Bol:     p:='Bol';
   Eol:     p:='Eol';
   Any:     p:='Any';
   AnyOf:   p:='AnyOf';
   AnyBut:  p:='AnyBut';
   Braunh:  p:='Branch';
   Exactly: p:='Exactly';
   Nothing: p:='Nothing';
   Back:    p:='Back';
   Pend:    p:='End';
   Open+1,
   Open+2,
   Open+3,
   Open+4,
   Open+5,
   Open+6,
   Open+7,
   Open+8,
   Open+9:
    begin
     Str(RegOpPtr(op)^.OP-Open,p);
     Buf:=Buf+'Open'+p;
     p:='';
    end;
   Close+1,
   Close+2,
   Close+3,
   Close+4,
   Close+5,
   Close+6,
   Close+7,
   Close+8,
   Close+9:
    begin
     Str(RegOpPtr(op)^.Op-Close,p);
     Buf:=Buf+'Close'+p;
     p:='';
    end;
   Star:    p:='Star';
   Plus:    p:='Plus';
   else     RegError('corrupted opcode');
  end;
  if p<>'' then  Buf:=Buf+p;
  RegProp:=Buf;
 end;
{$EndIf}
end.
